module Mailstro
  class Configuration
    attr_accessor :api_endpoint
    attr_accessor :api_key
    attr_accessor :enabled

    def initialize
      @api_endpoint = 'https://api.mailstroapp.com/v1'
    end

    def enabled=(value)
      if value
        Mailstro.strategy = ProductionStrategy
      else
        Mailstro.strategy = TestStrategy
      end
    end

    def validate!
      raise Error::ConfigurationError, "api_key not provided" if api_key.nil?
    end
  end
end
