module Mailstro
  module TestStrategy
    def self.enable
      Mailstro.strategy = Mailstro::TestStrategy
    end

    @@deliveries = []

    def self.clear
      @@deliveries = []
    end

    def self.deliver(email_name, options)
      @@deliveries << Delivery.new(email_name, options)
    end

    def self.has_delivered?(email_name, conditions)
      @@deliveries.any? do |delivery|
        result = delivery.email_name == email_name
        if conditions[:to]
          result = result && delivery.to == conditions[:to]
        end
        result
      end
    end
  end
end
